//---------------------------------------------------------------------------
#include <vcl.h>
#include <winreg.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    AnsiString w;
    HKEY key;
    DWORD trash;
    DWORD value;
    DWORD size;

    size = sizeof(DWORD);
    if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\marumo\\mpeg2vid_vfp", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &key, &trash) != ERROR_SUCCESS){
        Close();
    }

    if(ignore_aspect_ratio->Checked){
        value = 0;
    }else{
        value = 1;
    }
    RegSetValueEx(key, "aspect_ratio", 0, REG_DWORD, (LPBYTE)&value, size);

    if(no_remap->Checked){
        value = 0;
    }else{
        value = 1;
    }
    RegSetValueEx(key, "re_map", 0, REG_DWORD, (LPBYTE)&value, size);

    if(idct_double->Checked){
        value = 0;
    }else if(idct_llm->Checked){
        value = 1;
    }else{
        value = 1;
    }
    RegSetValueEx(key, "idct_func", 0, REG_DWORD, (LPBYTE)&value, size);

    if(keep_frame->Checked){
        value = 0;
    }else if(top_first->Checked){
        value = 1;
    }else{
        value = 2;
    }
    RegSetValueEx(key, "field_order", 0, REG_DWORD, (LPBYTE)&value, size);

    value = 0;
    if(mmx->Checked){
        value |= 1;
    }
    if(sse->Checked){
        value |= 2;
    }
    if(sse2->Checked){
        value |= 4;
    }
    RegSetValueEx(key, "simd", 0, REG_DWORD, (LPBYTE)&value, size);

    RegCloseKey(key);

    if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\VFPlugin", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &key, &trash) != ERROR_SUCCESS){
        Close();
    }
    w = ExtractFileDir(ParamStr(0));
    w = w + "\\m2v.vfp";

    RegSetValueEx(key, "MPEG2VIDEO", 0, REG_SZ, (LPBYTE)w.c_str(), w.Length());
    RegCloseKey(key);

    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    HKEY key;
    DWORD type;
    DWORD value;
    DWORD size;

    size = sizeof(DWORD);
    type = REG_DWORD;

    if(is_mmx_enable()){
        mmx->Enabled = true;
    }else{
        mmx->Checked = false;
        mmx->Enabled = false;
    }

    if(is_sse_enable()){
        sse->Enabled = true;
    }else{
        sse->Enabled = false;
        sse->Checked = false;
    }

    this->set_language();

	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\marumo\\mpeg2vid_vfp", 0, KEY_READ, &key) != ERROR_SUCCESS){
        remap->Checked = true;
        idct_llm->Checked = true;
        return;
    }

	if(RegQueryValueEx(key, "idct_func", NULL, &type, (LPBYTE)&value, &size) != ERROR_SUCCESS){
		idct_llm->Checked = true;
    }else{
        switch(value){
        case 0:
            idct_double->Checked = true;
            break;
        case 1:
            idct_llm->Checked = true;
            break;
        default:
            idct_llm->Checked = true;
        }
    }

	if(RegQueryValueEx(key, "simd", NULL, &type, (LPBYTE)&value, &size) != ERROR_SUCCESS){
        mmx->Checked = false;
        sse->Checked = false;
    }else{
        if( (value & 1) && mmx->Enabled){
            mmx->Checked = true;
        }else{
            mmx->Checked = false;
        }
        if( (value & 2) && sse->Enabled){
            sse->Checked = true;
        }else{
            sse->Checked = false;
        }
    }

	if(RegQueryValueEx(key, "re_map", NULL, &type, (LPBYTE)&value, &size) != ERROR_SUCCESS){
        remap->Checked = true;
    }else{
        if(value){
            remap->Checked = true;
        }else{
            no_remap->Checked = true;
        }
    }

	if(RegQueryValueEx(key, "aspect_ratio", NULL, &type, (LPBYTE)&value, &size) != ERROR_SUCCESS){
        use_aspect_ratio->Checked = true;
    }else{
        if(value){
            use_aspect_ratio->Checked = true;
        }else{
            ignore_aspect_ratio->Checked = true;
        }
    }

	if(RegQueryValueEx(key, "field_order", NULL, &type, (LPBYTE)&value, &size) != ERROR_SUCCESS){
        bottom_first->Checked = true;
    }else{
        switch(value){
        case 0:
            keep_frame->Checked = true;
            break;
        case 1:
            top_first->Checked = true;
            break;
        case 2:
            bottom_first->Checked = true;
            break;
        default:
            keep_frame->Checked = true;
        }
    }

    RegCloseKey(key);
}
//---------------------------------------------------------------------------
int TForm1::is_mmx_enable()
{
    DWORD mmx_check;


    _asm{
        mov eax,1;
        cpuid;
        mov mmx_check,edx;
    }

    if(mmx_check & 0x00800000){
        return 1;
    }else{
        return 0;
    }
}
//---------------------------------------------------------------------------
int TForm1::is_sse_enable()
{
    DWORD sse_check;

	if(!is_mmx_enable()) return 0;

	__asm{
		mov eax, 1
		cpuid
		mov sse_check, edx
	}

	if (sse_check & 0x02000000){
	    return 1;
    }else{
        return 0;
    }
}
//---------------------------------------------------------------------------
void TForm1::set_language()
{
    LANGID id;

    id = GetUserDefaultLangID();

    if(id == 0x0411){
        this->Label1->Font->Charset = DEFAULT_CHARSET;
        this->Label1->Font->Name = "lr SVbN";

        this->Font->Charset = DEFAULT_CHARSET;
        this->Font->Name = "lr SVbN";

        this->Caption = "MPEG-2 VIDEO VFAPI Plug-In ݒ";
        this->Label1->Caption = "MPEG-2 VIDEO VFAPI Plug-In ݒ";
        this->GroupBox5->Caption = "AXyNg";
        this->GroupBox1->Caption = "YUV  RGB ϊ";
        this->GroupBox2->Caption = "IDCT ֐";
        this->GroupBox3->Caption = "CPU g";
        this->GroupBox4->Caption = "tB[h";
        this->ignore_aspect_ratio->Caption = "";
        this->use_aspect_ratio->Caption = "f";
        this->no_remap->Caption = "Xg[gϊ";
        this->remap->Caption = "ITU-R BT.601 L";
        this->idct_double->Caption = "_";
        this->idct_llm->Caption = " (32bit LLM)";
        this->keep_frame->Caption = "\[Xt[ێ";
        this->top_first->Caption = "gbv{gŏo";
        this->bottom_first->Caption = "{ggbvŏo";
        this->Button1->Caption = "";
        this->Button2->Caption = "";
    }
}
//---------------------------------------------------------------------------
